import java.io.IOException;
import java.io.PrintWriter;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.jnp.interfaces.NamingContext;

public class JNDITest extends HttpServlet
{

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public JNDITest()
    {
    }

   /* protected void doGet(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException
    {
        try
        {
            Context ctx = new InitialContext();
            Context ds = (Context)ctx.lookup("java:comp/env");
            Object ldapCtx = ds.lookup("jndi/externalLDAP");
            PrintWriter w = response.getWriter();
            w.print(ldapCtx);
        }
        catch(NamingException e)
        {
            throw new ServletException(e);
        }
    }*/
    
    
	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse
	 *      response)
	 */
	protected void doGet(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {

		
		PrintWriter _writer = response.getWriter();
		Context _intialCtx = null;
		NamingContext _envCtx = null;
		Context _ldapObj = null;
				
		try {
			// Create the initial context
			_intialCtx = new InitialContext();

			// first lookup for java: to retrieve context
			_envCtx = (NamingContext) _intialCtx.lookup("java:");
			if (_envCtx != null) {
				_writer.print(_envCtx.getClass().getName() + "<br/>");
				_writer.print(_envCtx.toString() + "<br/>"
						+ _envCtx.getEnvironment());
			} else
				_writer.print("Env context is null!");

			// second lookup for external/ldap/jboss: to retrieve the Object
			_ldapObj = (Context) _envCtx.lookup("external/ldap/jboss");
			if (_ldapObj != null) {
				_writer.print(_ldapObj + "<br/>");
				_writer.print(_ldapObj.getClass().getName() + "<br/>"
						+ _ldapObj.getEnvironment() + "<br/>");
			}
			_writer.println("<br/>Typecasting<br/>");
			
			/** Next line gives ClassCastException */
			//LocalOnlyContextFactory typeCtx =(LocalOnlyContextFactory)_ldapObj;
			//LocalOnlyContextFactory typeCtxContextFactory = new LocalOnlyContextFactory();
		
			/**
			 * This is the location, the object should be LocalOnlyContextFactory object.
			 * Unfortunately, I am unable to cast. 
			 * 
			 * I had managed to get InitialContext(as shown below), 
			 * similarly is there anyway to get LocalOnlyContextFactory Object?
			 *  
			 * My Custom class extends LocalOnlyContextFactory, so if i manage to 
			 * get LocalOnlyFactoryObject, It should also work with my CustomClass.
			 *  
			 */
			
			// Typecasting to InitialContext			
			InitialContext initialContext = new InitialContext(_ldapObj
					.getEnvironment());
			_writer.println(initialContext.toString() + "<br/>");
			_writer.println(initialContext.getEnvironment());
			
		
			
		} catch (Exception e) {
			_writer.print(e.toString());
			e.printStackTrace();
		} finally {
			_writer = null;
			_intialCtx = null;
			_envCtx = null;
		}
	}
}
